<script>

	import { onMount, onDestroy, beforeUpdate, afterUpdate, createEventDispatcher } from 'svelte';
  import Cell from './Cell.svelte';

	const dispatch = createEventDispatcher();
	
  const GRID_SIZE = 100;

  export let playerRoles      = [];
  export let raw              = false;
  export let _id              = '';
  export let x                = 0;
  export let y                = 0;
  export let image            = '';
  export let label            = '';
  export let shape            = [];
  export let actions          = [];
  export let count            = 1;
  export let drag             = null;
	export let currentContainer = null;
	export let currentItem      = null;
	export let mouseX           = 0;
  export let mouseY           = 0;
  export let state            = -1;
  export let container        = '';
  
	export let getShape       = null;
	export let computeShapes  = null;
	export let check          = null;
	export let getImage       = null;
	export let setDraggedItem = null;
  export let getCache       = null;
  export let setDragCount   = null;

  export let isBody = false;

  let img            = '';
  let offset         = {x: 0, y: 0};
  let contextVisible = false;
  let contextX       = 0;
  let contextY       = 0;

  let _shape         = [];
  let _lastCount     = count;
  let _selectedCount = count;

  function onMouseDown(e) {
    
    e.preventDefault();
    
    if(e.button === 0)
      setDraggedItem(_id, container, _selectedCount);
  }

  function onMouseWheel(e) {

    e.preventDefault();
    e.stopPropagation();

    if(e.deltaY < 0) {

    _selectedCount++;

      if(_selectedCount > count)
        _selectedCount = count;

    } else if(e.deltaY > 0) {

      _selectedCount--;

      if(_selectedCount < 1)
        _selectedCount = 1;

    }

    setDragCount(_selectedCount);

  }

  function onContextMenu(e) {
    
    e.preventDefault();

    if(isBody)
      return;

    contextX       = e.screenX;
    contextY       = e.screenY;
    contextVisible = true;

  }

  function onAction(e, action) {
    
    e.stopPropagation();
    contextVisible = false;

    window.parent.postMessage(JSON.stringify({action: 'item_action', _id, itemAction: action}), '*');
  }

  function onAdminAction(e, action) {
    
    e.stopPropagation();
    contextVisible = false;

    window.parent.postMessage(JSON.stringify({action: 'item_action_admin', _id, itemAction: action}), '*');
  }

  function onImgError(e) {
    
    this.onerror = null;
    this.src     = 'http://assets/core-assets/dist/img/items/undefined.png';

    return true;
  }

  beforeUpdate(() => {

    img           = getImage(_id);
    const result  = getShape(shape);
    _shape        = result.shape;
    offset        = result.offset;

    if(count !== _lastCount) {
      _selectedCount = count;
      _lastCount     = count;
    }

    if((drag === _id) && currentContainer && currentItem) {

      x = mouseX;
      y = mouseY;
      
      if(check(currentContainer, currentItem, x, y))
        state = 1;
      else
        state = 0;
    }

  });

</script>

<style>
  .item {
    position: absolute;
    user-select: none;
  }

  .item .count {
    position: absolute;
    left: 1px;
    top: 1px;
    border: 1px solid rgb(71, 2, 129);
    background-color: rgb(129, 44, 44);
    line-height: 14px;
    font-weight: bold;
    text-align: center;
    color: #fff;
    height: 14px;
    z-index: 100;
    padding: 3px;
    white-space: nowrap;
  }

  .item .count > span:nth-child(3) {
    font-size: 0.75em;
  }

  .item.raw {
    position: relative;
    left: unset !important;
    top: unset !important;
    clear: both;
  }

  .item.raw .image {
    position: unset;
    margin: 0;
  }

  .item.disablemouse {
    pointer-events: none;
  }
  
  .grid {
    position: relative;
  }

  .image {
    position: absolute;
  }

  .context {
    position: fixed;
    min-width: 200px;
    background-color: rgba(0, 0, 0, 0.8);
    z-index: 1000;
  }

  .context-action {
    text-align: center;
    color: #FFF;
    height: 32px;
    line-height: 32px;
  }

  .context-action:hover {
    background-color: rgba(50, 50, 50, 0.8);
  }

  .context-action.label {
    border-bottom: 1px solid #333;
  }

  .context-action.label:hover {
    background-color: rgba(0, 0, 0, 0.8);
  }

  .context-action.close:hover {
    background-color: rgba(0, 0, 0, 0.8);
    color: red;
  }

</style>

<div class="item {!!drag ? 'disablemouse' : ''} {raw ? 'raw' : ''}" style="left: {x * GRID_SIZE}px; top: {y * GRID_SIZE}px;" on:mousedown={onMouseDown} on:contextmenu={onContextMenu} on:mousewheel={onMouseWheel}>
  {#if !raw}
    <div class="grid">
      {#each shape.grid as cell, index}
        <Cell x={(cell.x + shape.offset.x) / GRID_SIZE} y={(cell.y + shape.offset.y) / GRID_SIZE} {state}/>
      {/each}
    </div>
  {/if}
  {#if _selectedCount > 1}
    <div class="count">
      <span>{_selectedCount}</span>
    </div>
  {/if}
  <div class="image">
    <img src={img} alt={_id} style="margin-left: {raw ? 0 : offset.x}px; margin-top: {raw ? 0 : offset.y}px;" on:error={onImgError}/>
  </div>
  {#if contextVisible}
    <div class="context" style="left: {contextX}px; top: {contextY}px;">
      <div class="context-action label">{label}</div>
      {#if !!currentItem && currentItem._type === 'ItemKey'}
        <div class="context-action">{currentItem.targets.filter(e => !!e && e.type === 'vehicle').map(e => e.plate).join(', ')}</div>
      {/if}
      {#if playerRoles.indexOf('admin') !== -1}
        <div class="context-action" on:mousedown={e => onAdminAction(e, 'delete_item')}>(admin) Delete Item</div>
      {/if}
      {#each actions as action}
        <div class="context-action" on:mousedown={e => onAction(e, action)}>{action}</div>
      {/each}
      <div class="context-action close" on:mousedown={e => {e.stopPropagation(); contextVisible = false}}>Fermer</div>
    </div>
  {/if}
</div>

